const exampleSpaceId = process.env.CONTENTFUL_SPACE_ID;
const exampleAccessKey = process.env.CONTENTFUL_ACCESS_KEY;
const exampleContentType = 'book';

const Contentpull = require('contentpull');
const contentpull = new Contentpull(exampleSpaceId, exampleAccessKey);

await contentpull.getEntriesByType(exampleContentType);;

class Dal extends Contentpull {
    
    getBooks() {
        return this.getEntriesByType(exampleContentType);
    }
    
}

const dal = new Dal(exampleSpaceId, exampleAccessKey);

await dal.getBooks();;

await dal.getBooks().parse().then(books => {
    return `The first book's author is '${books.items[0].fields.author}'.`
});;

const ParsingExample = new Contentpull(exampleSpaceId, exampleAccessKey, {
    parsers: {
        Asset: (asset) => {
            return asset;
        },
        Array: (array, parser) => {
            array.foo = 'bar';
            delete array.sys;
            array.items.map(item => parser(item));
            return array;
        }
    }
});

await ParsingExample.getEntriesByType(exampleContentType).parse();;